## xjobs 20241010

=== CMakeLists.txt ===
#
#  Copyright (C) 2019, Thomas Maier-Komor
#
#  This file is part of xjobs.
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

cmake_minimum_required(VERSION 3.0.0)

include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CheckSymbolExists)
include(CMakePrintHelpers)

project(xjobs C)

find_package(FLEX)

add_compile_options("-Wall")

check_include_file(sys/wait.h HAVE_WAIT_H)
check_include_file(ncurses.h HAVE_NCURSES_H)
check_include_file(curses.h HAVE_CURSES_H)
check_include_file(term.h HAVE_TERM_H)

check_symbol_exists(wait4 sys/wait.h HAVE_WAIT4)
check_symbol_exists(strerror string.h HAVE_STRERROR)
check_symbol_exists(mmap sys/mman.h HAVE_MMAP)

### posix spawn is per default disabled, as fork is faster
#check_symbol_exists(posix_spawn spawn.h HAVE_SPAWN)

find_library(LIBM m)
if (LIBM)
	set(LIBS ${LIBS} ${LIBM})
endif()

find_library(LIBNCURSES ncurses)
if (LIBNCURSES)
	set(LIBS ${LIBS} ${LIBNCURSES})
else()
	find_library(LIBCURSES curses)
	if (LIBCURSES)
		set(LIBS ${LIBS} ${LIBCURSES})
	endif()
endif()

find_library(LIBTINFO tinfo)
if (LIBTINFO)
	set(LIBS ${LIBS} ${LIBTINFO})
endif()

FLEX_TARGET(tokenizer_l
	tokenizer.l
	${CMAKE_CURRENT_BINARY_DIR}/tokenizer.c
	COMPILE_FLAGS "-F"
)

configure_file(config.h.cm config.h)

add_custom_target(version_h COMMAND sh mkversion.sh)

add_executable(xjobs
	xjobs.c
	colortty.c
	jobctrl.c
	lexextra.c
	log.c
	settings.c
	support.c
	${FLEX_tokenizer_l_OUTPUTS}
)

add_dependencies(xjobs version_h)

target_link_libraries(xjobs ${LIBS})
set_property(TARGET xjobs PROPERTY C_STANDARD 11)

install(TARGETS xjobs
	PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
	DESTINATION bin
)

install(FILES xjobs.1
	DESTINATION man/man.1
	PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
)

install(CODE "execute_process(COMMAND bash -c \"
	mkdir -p ${CMAKE_INSTALL_PREFIX}/etc;
	if [ ! -f ${CMAKE_INSTALL_PREFIX}/etc/xjobs.rc ]; then
		cp -n xjobs.rc ${CMAKE_INSTALL_PREFIX}/etc &&
		chmod 0644 ${CMAKE_INSTALL_PREFIX}/etc/xjobs.rc &&
		echo installed ${CMAKE_INSTALL_PREFIX}/etc/xjobs.rc ||
		echo failed to install ${CMAKE_INSTALL_PREFIX}/etc/xjobs.rc;
	else
		echo please update existing ${CMAKE_INSTALL_PREFIX}/etc/xjobs.rc manually;
	fi\"
	)"
)

## xjobs 20110730

=== debian/changelog ===
xjobs (20110730-1) unstable; urgency=low

  * Initial release (Closes: #572325)

 -- Thierry Randrianiriana <thierry@debian.org>  Sat, 29 Oct 2011 21:05:39 +0300

=== debian/control ===
Source: xjobs
Section: utils
Priority: extra
Maintainer: Thierry Randrianiriana <thierry@debian.org>
Build-Depends: autotools-dev,
 cdbs (>= 0.4.85~),
 debhelper (>= 8~),
 dh-buildinfo, autotools-dev, flex
Standards-Version: 3.9.2
Homepage: http://www.maier-komor.de/xjobs.html

Package: xjobs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: reads job description line by line and executes them in parallel
 xjobs reads job descriptions line by line and executes them in parallel. It 
 limits the number of parallel executing jobs and starts new jobs when jobs 
 finish. Therefore, it combines the arguments from every input line with the 
 utility and arguments given on the command line. If no utility is given as an 
 argument to xjobs, then the first argument on every job line will be used as 
 utility. To execute utility xjobs searches the directories given in the PATH 
 environment variable and uses the first file found in these directories. 
 .
 xjobs is most useful on multi-processor/core machines when one needs to execute 
 several time consuming command several that could possibly be run in parallel. 
 With xjobs this can be achieved easily, and it is possible to limit the load 
 of the machine to a useful value. It works similar to xargs, but starts several 
 processes simultaneously and gives only one line of arguments to each utility 
 call.

=== debian/watch ===
version=3
http://www.maier-komor.de/xjobs/xjobs-(.*)\.tgz

## xjobs 20120412

=== debian/changelog ===
xjobs (20120412-1) unstable; urgency=low

  * New upstream release
  * debian/control:
    + Bump Standars-Version to 3.9.4
  * Updated debian/watch

 -- Thierry Randrianiriana <thierry@debian.org>  Sun, 09 Jun 2013 05:38:56 +0300

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: utils
 Priority: extra
 Maintainer: Thierry Randrianiriana <thierry@debian.org>
-Build-Depends: autotools-dev,
- cdbs (>= 0.4.85~),
- debhelper (>= 8~),
+Build-Depends: cdbs,
+ autotools-dev,
+ debhelper,
  dh-buildinfo, autotools-dev, flex
-Standards-Version: 3.9.2
+Standards-Version: 3.9.4
 Homepage: http://www.maier-komor.de/xjobs.html
 
 Package: xjobs

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DEB_AUTO_UPDATE_DEBIAN_CONTROL = no

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk

=== debian/watch ===
version=3
http://www.maier-komor.de/xjobs.html .*/xjobs-(\d.*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
# Bart Martens <bartm@debian.org>  Fri, 28 Dec 2012 22:44:14 +0000

## xjobs 20241010

=== debian/changelog ===
xjobs (20241010-2) unstable; urgency=medium

  * d/control: fix Vcs links (were /ossp-uuid instead of /xjobs)
  * d/p/0002: fix hurd FTBFS
    + Remove dependency on PATH_MAX
    + Don't overflow static buffer if input line longer than PATH_MAX
    + Don't change xecutable-searching behaviour if -v4

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Mon, 09 Dec 2024 19:04:15 +0100

xjobs (20241010-1) unstable; urgency=medium

  [ наб ]
  * d/watch: version 4
  * New upstream version 20241010
    (Closes: #1066652, #755511, #966376, #716517)
  * cdbs -> debhelper 13 (+ hardening)
  * R-R-R: no
  * Standards-Version: 4.7.0
  * New maintainer: the salvage team (Closes: #1084091)
  * Vcs-Git: https://salsa.debian.org/salvage-team/ossp-uuid.git
  * Priority: extra -> optional
  * d/copyright: canonical DEP5 location
  * d/copyright: Upstream-Contact
  * add d/p/0003-blhc.diff
    (Forward CPPFLAGS correctly too, needed for hardening)

  [ Andreas Tille ]
  * Use secure URI in Homepage field.
  * Secure URI in watch file

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Sat, 05 Oct 2024 00:29:54 +0200

=== debian/control ===
Source: xjobs
Section: utils
Priority: optional
Maintainer: Package Salvaging Team <team+salvage@tracker.debian.org>
Uploaders: наб <nabijaczleweli@nabijaczleweli.xyz>
Build-Depends: debhelper, debhelper-compat (= 13), flex
Standards-Version: 4.7.0
Homepage: https://www.maier-komor.de/xjobs.html
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/salvage-team/xjobs.git
Vcs-Browser: https://salsa.debian.org/salvage-team/xjobs

Package: xjobs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: reads job description line by line and executes them in parallel
 xjobs reads job descriptions line by line and executes them in parallel. It
 limits the number of parallel executing jobs and starts new jobs when jobs
 finish. Therefore, it combines the arguments from every input line with the
 utility and arguments given on the command line. If no utility is given as an
 argument to xjobs, then the first argument on every job line will be used as
 utility. To execute utility xjobs searches the directories given in the PATH
 environment variable and uses the first file found in these directories.
 .
 xjobs is most useful on multi-processor/core machines when one needs to execute
 several time consuming command several that could possibly be run in parallel.
 With xjobs this can be achieved easily, and it is possible to limit the load
 of the machine to a useful value. It works similar to xargs, but starts several
 processes simultaneously and gives only one line of arguments to each utility
 call.

=== debian/rules ===
#!/usr/bin/make -f

override_dh_auto_configure:
	dh_auto_configure -- $(shell dpkg-buildflags --export=cmdline)

%:
	dh $@

=== debian/watch ===
version=4
https://www.maier-komor.de/xjobs.html \
	.*/xjobs-@ANY_VERSION@@ARCHIVE_EXT@
